#include <htc.h>
#include "user_define_amfm.h"

extern unsigned char	bank_no;
extern unsigned char	preset_no;
extern unsigned int		preset[PRESET_MAX];
extern unsigned int		mhz_no;
extern unsigned char	mode;
extern unsigned char	width;
extern unsigned char	band_count;

/*----------EEPROM----------*/
unsigned char E2promRead(unsigned char adr)
{
	EEADR=adr;
	RD=1;
	return(EEDATA);
}

void E2promWrite(unsigned char adr,unsigned char data)
{
	EEADR=adr;
	EEDATA=data;
	
	WREN=1;
	EECON2=0x55;
	EECON2=0xaa;
	
	WR=1;
	while(EEIF==0)
	{
		NOP();
	}
	EEIF=0;
	WREN=0;
}

void	eeprom_write_sub(unsigned char	no)
{
unsigned char	i;

	for(i=0;i<PRESET_MAX;i++){
		E2promWrite(no*0x30+0x10+i*2,(unsigned char)(preset[i]%256));
		E2promWrite(no*0x30+0x11+i*2,(unsigned char)(preset[i]/256));
	}
}

void	eeprom_init(void)
{
unsigned char	i;

		E2promWrite(0x00,0xa5);

		for(i=1;i<PRESET_MAX;i++){
			preset[i]=0;
		}

		preset[0]=FREQ_CH0;
		mhz_no=FREQ_MIN_AM;		
		eeprom_write_sub(0);
		E2promWrite(0x0a,(unsigned char)(mhz_no%256));
		E2promWrite(0x0b,(unsigned char)(mhz_no/256));
		E2promWrite(0x08,preset_no);
		E2promWrite(0x05,mode);
		
		eeprom_write_sub(1);
		E2promWrite(0x30+0x0a,(unsigned char)(mhz_no%256));
		E2promWrite(0x30+0x0b,(unsigned char)(mhz_no/256));
		E2promWrite(0x30+0x08,preset_no);
		E2promWrite(0x30+0x05,mode);

		eeprom_write_sub(2);
		E2promWrite(2*0x30+0x0a,(unsigned char)(mhz_no%256));
		E2promWrite(2*0x30+0x0b,(unsigned char)(mhz_no/256));
		E2promWrite(2*0x30+0x08,preset_no);
		E2promWrite(2*0x30+0x05,mode);

		eeprom_write_sub(3);
		E2promWrite(3*0x30+0x0a,(unsigned char)(mhz_no%256));
		E2promWrite(3*0x30+0x0b,(unsigned char)(mhz_no/256));
		E2promWrite(3*0x30+0x08,preset_no);
		E2promWrite(3*0x30+0x05,mode);

		bank_no=0;
		E2promWrite(0x0c,bank_no);

		width=2;
		E2promWrite(0x0e,width);

		band_count=0;
		E2promWrite(0x0d,band_count);

		preset[0]=FREQ_CH0;
}
void	eeprom_read_preset(void)
{
unsigned char	i;
unsigned int sub0,sub1;

		for(i=0;i<PRESET_MAX;i++){
			sub0=(unsigned int)E2promRead((bank_no)*0x30+0x10+i*2);
			sub1=(unsigned int)E2promRead((bank_no)*0x30+0x11+i*2);
			preset[i]=sub0+sub1*256;
		}
}

void	eeprom_check(void)
{
unsigned int sub0,sub1;

	if(E2promRead(0x00)==0xa5){
		bank_no=E2promRead(0x0c);
		width=E2promRead(0x0e);
		band_count=E2promRead(0x0d);
		sub0=(unsigned int)E2promRead((bank_no)*0x30+0x0a);
		sub1=(unsigned int)E2promRead((bank_no)*0x30+0x0b);
		mhz_no=sub0+sub1*256;
		preset_no=E2promRead((bank_no)*0x30+0x08);
		mode=eeprom_read((bank_no)*0x30+0x05);
		eeprom_read_preset();
		
	}
	else{
		eeprom_init();
	}
}

void	write_direct(void)
{
		E2promWrite(0x0c,bank_no);
		E2promWrite((bank_no)*0x30+0x0a,(unsigned char)(mhz_no%256));
		E2promWrite((bank_no)*0x30+0x0b,(unsigned char)(mhz_no/256));
		E2promWrite((bank_no)*0x30+0x08,preset_no);
		E2promWrite((bank_no)*0x30+0x05,mode);
}
void	write_direct_set(unsigned char	no)
{
		E2promWrite((bank_no)*0x30+0x10+no*2,(unsigned char)(preset[no]%256));
		E2promWrite((bank_no)*0x30+0x11+no*2,(unsigned char)(preset[no]/256));
}
void	write_direct_width(void)
{
		E2promWrite(0x0e,width);
}
void	write_direct_band(void)
{
		E2promWrite(0x0d,band_count);
}