#define _LEGACY_HEADERS

#include <htc.h>
#include <pic16f886.h>
#include "lcd_sub.h"
#include "port_init.h"
#include "wait_time.h"
#include "user_define.h"
#include "cpld.h"

__CONFIG(	DEBUGDIS & LVPDIS & FCMDIS & IESODIS & BORDIS
			& DUNPROTECT & UNPROTECT & MCLREN & PWRTEN & WDTDIS & INTIO);
__CONFIG(	0xffff & BORV21);

unsigned char	sw1_key;
unsigned char	sw1_rep;
unsigned char	sw1_cnt;
unsigned char	sw2_key;
unsigned char	sw2_rep;
unsigned char	sw2_cnt;

unsigned char	freq_byte1;
unsigned char	freq_byte2;
unsigned char	freq_byte3;
unsigned char	freq_byte4;

unsigned char	f_count;
unsigned int	disp_count;

unsigned char	mode;
unsigned char	f_add;

unsigned char	sw1p;
unsigned char	sw2p;


/*---------------------MAIN-----------------------*/
void	main(void)
{

	port_init();

	__delay_ms(2000);

	sw1_key=0;sw1_rep=0;sw1_cnt=0;
	sw2_key=0;sw2_rep=0;sw2_cnt=0;

	mode=0;f_add=0;

	cpld_set(mode,f_add);

	lcd_init();
	lcd_clear();

	disp_count=DISP_COUNT_INIT;

	sw1p=RC0;NOP();
	sw2p=RB3;NOP();

	lcd_xy(0,0);
	lcd_print("FREQ.   ");
	lcd_xy(0,1);
	lcd_print(" COUNTER");

	__delay_ms(1000);

	lcd_xy(5,1);lcd_print("kHz");

	lcd_mode();

	while(1){

		sw1p=RC0;NOP();
		sw2p=RB3;NOP();

	/* key scan 1 */
		if (sw1p==0){
				sw1_key=0;
		}
		else{
			sw1_key=1;
			sw1_rep=0;
			sw1_cnt=0;
		}
		/*------------------*/
		if (sw2p==0){
				sw2_key=0;
		}
		else{
			sw2_key=1;
			sw2_rep=0;
			sw2_cnt=0;
		}
		/*------------------*/

		wait_time(1000);

		sw1p=RC0;NOP();
		sw2p=RB3;NOP();

	/* key scan 2 */
		if ((sw1p==0)&&(sw1_key==0)){
			sw1_key=0;
		}
		else{
			sw1_key=1;
			sw1_rep=0;
			sw1_cnt=0;
		}
		/*------------------*/
		if ((sw2p==0)&&(sw2_key==0)){
			sw2_key=0;
		}
		else{
			sw2_key=1;
			sw2_rep=0;
			sw2_cnt=0;
		}
		/*------------------*/

	/* key action */
	
		if((sw1_key==0)&&(sw1_rep==0)){
			sw1_rep=1;
			switch(mode){
				case 0:	mode=1;f_add=1;break;
				case 1:	mode=0;f_add=0;break;
			}
			cpld_set(mode,f_add);
			lcd_mode();
		}
		/*------------------*/
		if((sw1_key==0)&&(sw1_rep==1)){
			sw1_cnt++;
			if(sw1_cnt>=30){
				sw1_cnt=0;		


				
			}
		}
		/*------------------*/
		if((sw2_key==0)&&(sw2_rep==0)){
			sw2_rep=1;
			switch(mode){
				case 0:	switch(f_add){
							case 0:	f_add=1;break;
							case 1:	f_add=0;break;
						}
						break;
			}
			cpld_set(mode,f_add);
			lcd_mode();
		}
		/*------------------*/
		if((sw2_key==0)&&(sw2_rep==1)){
			sw2_cnt++;
			if(sw2_cnt>=30){
				sw2_cnt=0;		


					
			}
		}
		/*------------------*/
		if(disp_count>0){
			disp_count--;
			if(disp_count==0){
				disp_count=DISP_COUNT_INIT;
				cpld_freq_in();
				lcd_xy(0,0);
				lcd_freq();		
			}
		}

	}

}